# THEME MANAGER

ui_local_style_list = {}

class _ui_theme_variable:
    def __init__(self):
        self.target = None
        self.color = 0

def ui_object_set_themeable_style_property(target, selector, property, coloridx):

   if not (id(target) in ui_local_style_list):
      ui_local_style_list[id(target)] = {}

   if not property in ui_local_style_list[id(target)]:
      ui_local_style_list[id(target)][property] = {}

   ui_local_style_list[id(target)][property][selector] = _ui_theme_variable()
   ui_local_style_list[id(target)][property][selector].target = target
   ui_local_style_list[id(target)][property][selector].color = coloridx
   ui_update_theme_value( target, property, selector )

def ui_update_theme_value(target, property, selector):

   if not (id(target) in ui_local_style_list):
       return

   if not property in ui_local_style_list[id(target)]:
       return

   if not selector in ui_local_style_list[id(target)][property]:
       return

   coloridx = ui_local_style_list[id(target)][property][selector].color
   color = lv.style_value_t()

   if (property ==  lv.STYLE.BG_COLOR or
          property == lv.STYLE.BG_GRAD_COLOR or
          property == lv.STYLE.BORDER_COLOR or
          property == lv.STYLE.OUTLINE_COLOR or
          property == lv.STYLE.TEXT_COLOR or
          property == lv.STYLE.LINE_COLOR or
          property == lv.STYLE.ARC_COLOR or
          property == lv.STYLE.SHADOW_COLOR or
          property == lv.STYLE.BG_IMAGE_RECOLOR or
          property == lv.STYLE.IMAGE_RECOLOR ):
      color.color = lv.color_hex(ui_theme_current_colors[coloridx])
   else: color.num = ui_theme_current_alphas[coloridx]
   target.set_local_style_prop(property,color,selector)

def ui_theme_manager_reset():
   ui_local_style_list = {}

def ui_theme_update_all():
   for obj in ui_local_style_list:
      targetid = obj
      proplist = ui_local_style_list[obj]
      for prop in proplist:
         lvprop = prop
         selectlist = ui_local_style_list[obj][prop]
         for select in selectlist:
            lvselect = select
            target = ui_local_style_list[obj][prop][lvselect].target
            ui_update_theme_value(target, lvprop,lvselect)

def ui_theme_set( index ):
   global ui_theme_current_colors
   global ui_theme_current_alphas
   ui_theme_current_colors = _ui_theme_list_colors[index]
   ui_theme_current_alphas = _ui_theme_list_alphas[index]
   ui_theme_update_all()

ui_theme_manager_reset()
